<?php
/**
* @copyright	Copyright (C) 2013 Jsn Project company. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		Easy Profile
* website		www.easy-profile.com
* Technical Support : Forum -	http://www.easy-profile.com/support.html
*/

defined('_JEXEC') or die;

class PlgJsnGdpr extends JPlugin
{
	protected $autoloadLanguage = true;

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		JFormHelper::addFieldPath(__DIR__ . '/field');
	}

	public function onContentPrepareForm($form, $data)
	{
		if (!($form instanceof JForm))
		{
			$this->_subject->setError('JERROR_NOT_A_FORM');

			return false;
		}

		if(isset($data->id))  $id=JFactory::getApplication()->getUserState('com_users.edit.profile.id',$data->id);
		else $id=JFactory::getApplication()->getUserState('com_users.edit.profile.id',JFactory::getApplication()->input->get('id',null));
		
		// Owner User
		if($id==0) $user=new JUser();
		else $user=JsnHelper::getUser($id);

		$name = $form->getName();
		$app = JFactory::getApplication();

		// Visitor User
		$userVisitor=JFactory::getUser();

		if($app->isAdmin()){
			return true;
		}

		if($userVisitor->id != $id){
			return true;
		}

		if($user->authorise('core.admin')){
			return true;
		}

		if($name=='com_users.profile' && $app->input->get('option','')=='com_users' && ($app->input->get('layout')=='edit' || $app->input->get('task','')!='')) {
			JForm::addFormPath(__DIR__ . '/form');
			$form->loadFile('gdpr', false);

		}
	}

	public function onAfterDispatch()
	{
		$app = JFactory::getApplication();
		if($app->isAdmin()){
			return true;
		}
		if(!$app->input->get('deleteaccount',false)){
			return true;
		}

		$user=JFactory::getUser();
		if($user->authorise('core.admin')){
			return true;
		}

		if(!$user->id || ($app->get('offline') && !$user->authorise('core.login.offline'))){
			return true;
		}

		if(!JSession::checkToken('get')){
			die('Not Valid Token');
		}

		if($this->params->get('action', 0)){
			// DELETE ACCOUNT
			if($app->logout() && $user->delete()){
				$session = JFactory::getSession();
				$session->set('user', null);
				$this->_sendEmail($user);
				$app->enqueueMessage(JText::_('PLG_JSN_DELETEACCOUNT_ACCOUNTDELETED'));
			}
			else $app->enqueueMessage(JText::_('PLG_JSN_DELETEACCOUNT_ERROR'),'error');
		}
		else{
			// BLOCK ACCOUNT
			$user->set('block', 1);
			if($user->save() && $app->logout()){
				$this->_sendEmail($user);
				$app->enqueueMessage(JText::_('PLG_JSN_DELETEACCOUNT_ACCOUNTBLOCKED'));
			}
			else $app->enqueueMessage(JText::_('PLG_JSN_DELETEACCOUNT_ERROR'),'error');
		}
	}

	public function _sendEmail($user)
	{
		$config = JFactory::getConfig();
		$data['fromname'] = $config->get('fromname');
		$data['mailfrom'] = $config->get('mailfrom');
		
		$emailSubject = JText::_('PLG_JSN_DELETEACCOUNT_EMAIL_SUBJECT');
		$emailBodyAdmin = JText::sprintf(
				'PLG_JSN_DELETEACCOUNT_EMAIL_BODY',
				$user->name, $user->id
			);

		$recipient = array();
		
		if($this->params->get('system_email', true)){
			$db = JFactory::getDbo();
			// Get all admin users
			$query = $db->getQuery(true);
			$query->select($db->quoteName(array('name', 'email', 'sendEmail')))
				->from($db->quoteName('#__users'))
				->where($db->quoteName('sendEmail') . ' = ' . 1);
	
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			
			// Send mail to all superadministrators id
			foreach ($rows as $row){
				$recipient[] = $row->email;
			}
		}
		
		if(empty($recipient)){
			return true;
		}
		
		$mail = JFactory::getMailer();
        $mail->setSender(
                array(
                        $data['mailfrom'],
                        $data['fromname']
                    )
            );
        $mail->addRecipient($recipient);
        $mail->setSubject($emailSubject);
        $mail->setBody($emailBodyAdmin);
							
		if (!$mail->Send()) {
			
		}
		
		return true;
	}


	
}

?>